package org.jboss.security;

package .tmp;

import java.security.Principal;
import javax.security.auth.Subject;
import org.jboss.security.SecurityAssociation;

public class SubjectContext {
  public static final int SUBJECT_WAS_SET = 1;
  
  public static final int PRINCIPAL_WAS_SET = 2;
  
  public static final int CREDENTIAL_WAS_SET = 4;
  
  private Subject subject;
  
  private Principal principal;
  
  private Object credential;
  
  private int flags;
  
  public SubjectContext() {
    this.flags = 0;
  }
  
  public SubjectContext(Subject s, Principal p, Object cred) {
    this.subject = s;
    this.principal = p;
    this.credential = cred;
    this.flags = 7;
  }
  
  public Subject getSubject() {
    return this.subject;
  }
  
  public void setSubject(Subject subject) {
    this.subject = subject;
    this.flags |= 0x1;
  }
  
  public Principal getPrincipal() {
    return this.principal;
  }
  
  public void setPrincipal(Principal principal) {
    this.principal = principal;
    this.flags |= 0x2;
  }
  
  public Object getCredential() {
    return this.credential;
  }
  
  public void setCredential(Object credential) {
    this.credential = credential;
    this.flags |= 0x4;
  }
  
  public int getFlags() {
    return this.flags;
  }
  
  public String toString() {
    StringBuffer tmp = new StringBuffer(super.toString());
    tmp.append("{principal=");
    tmp.append(this.principal);
    tmp.append(",subject=");
    if (this.subject != null) {
      tmp.append(System.identityHashCode(this.subject));
    } else {
      tmp.append("null");
    } 
    tmp.append("}");
    return tmp.toString();
  }
}
